class NodoLista:

    def __init__(self, value, succ):
        self.value = value
        self.succ = succ


def stampa_lista(testa):
    if testa is not None:
        print(testa.value)
        stampa_lista(testa.succ)


def accedi_indice(testa, i):
    nodo_corrente = testa
    posizione = 0
    while nodo_corrente is not None and posizione < i:
        nodo_corrente = nodo_corrente.succ
        posizione += 1
    return nodo_corrente


def ricerca(testa, x):
    nodo_corrente = testa
    while nodo_corrente is not None and nodo_corrente.value != x:
        nodo_corrente = nodo_corrente.succ
    return nodo_corrente


def inserisci_in_testa(testa, x):
    nuovo_nodo = NodoLista(x, testa)
    return nuovo_nodo


def inserisci(testa, x, i):
    if i == 0:
        testa = inserisci_in_testa(testa, x)
        return testa
    else:
        testa.succ = inserisci(testa.succ, x, i-1)
        return testa


def rimuovi(testa, nodo):
    if nodo == testa:
        return testa.succ
    else:
        nodo_corrente = testa
        while nodo_corrente.succ != nodo:
            nodo_corrente = nodo_corrente.succ
        nodo_corrente.succ = nodo.succ
        return testa


testa = NodoLista(12, NodoLista(3, NodoLista(8, None)))
nodo = ricerca(testa, 3)
testa = rimuovi(testa, nodo)
